// Wald


float abs(float x = 0) {
	if(x<0) {return(0.0-x);} else {return(x);}
}

string pointLoc(float fracX = 0, float fracZ = 0) {
	return(""+rmXFractionToMeters(fracX)+",0,"+
	rmZFractionToMeters(fracZ));
}

float PI = 3.141592;

float _pow(float n = 0,int x = 0) {
	float r = n;
	for(i = 1; < x) {
		r = r * n;
	}
	return (r);
}

float _atan(float n = 0) {
	float m = n;
	if(n > 1) m = 1.0 / n;
	if(n < -1) m = -1.0 / n;
	float r = m;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = _pow(m,j) / j;
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	if(n > 1 || n < -1) r = PI / 2.0 - r;
	if(n < -1) r = 0.0 - r;
	return (r);
}

float _atan2(float z = 0,float x = 0) {
	if(x > 0) return (_atan(z / x));
	if(x < 0) {
		if(z < 0) return (_atan(z / x) - PI);
		if(z > 0) return (_atan(z / x) + PI);
		return (PI);
	}
	if(z > 0) return (PI / 2.0);
	if(z < 0) return (0.0 - (PI / 2.0));
	return (0);
}

float _fact(float n = 0) {
	float r = 1;
	for(i = 1; <= n) {
		r = r * i;
	}
	return (r);
}

float _cos(float n = 0) {
	float r = 1;
	for(i = 1; < 100) {
		int j = i * 2;
		float k = _pow(n,j) / _fact(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}

float _sin(float n = 0) {
	float r = n;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = _pow(n,j) / _fact(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}











void main(void)
{

  // Text
   rmSetStatusText("",0.01);

   // Set size.

   int playerTiles=14000;
   if(cMapSize == 1)
   {
      playerTiles = 16000;
      rmEchoInfo("Large map");
   }
   int size=3*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);


   int classPlayer=rmDefineClass("player");
   int classCenter=rmDefineClass("center");
   int classinnerCenter=rmDefineClass("icenter");
   int classConnect=rmDefineClass("connect");
   int classStartingSettlement = rmDefineClass("starting settlement");
   int classPlaceForBuilding = rmDefineClass("classHill");
   int classBonusHuntable=rmDefineClass("bonus huntable");
   int classForest=rmDefineClass("forest");
   int classbetw=rmDefineClass("betw");

   int avoidBonusHuntable=rmCreateClassDistanceConstraint("avoid bonus huntable", classBonusHuntable, 30.0);
   int avoidHuntable=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 20.0);

   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 50.0);
   int betwConstraint=rmCreateClassDistanceConstraint("stay away from betw", classbetw, 10.0);

   int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 30.0);
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 10.0);
   int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 20.0);
   int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", classStartingSettlement, 60.0);
   int placeConstraint=rmCreateClassDistanceConstraint("objects free place", classPlaceForBuilding, 60.0);

   int smallinnerCenterConstraint=rmCreateClassDistanceConstraint("stay away from innerCenter a lot", classinnerCenter, 50.0);

   int smallCenterConstraint=rmCreateClassDistanceConstraint("stay away from Center a lot", classCenter, 10.0);
   int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4));
   int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
   int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 10.0);

   int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 20.0);
   int avoidTower2=rmCreateTypeDistanceConstraint("objects avoid towers", "tower", 22.0);


   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);

   int connectConstrain=rmCreateClassDistanceConstraint("stay away from Connect", classConnect, 20);
   int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 30.0);
   int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 20.0);
   int avoidFood=rmCreateTypeDistanceConstraint("avoid other food sources", "food", 6.0);
   int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 20.0);

   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 5.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 10.0);
   int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 20.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 15.0);




   rmTerrainInitialize("GrassDirt25");

   rmSetTeamSpacingModifier(0.75);
   if(cNumberNonGaiaPlayers <4)
      rmPlacePlayersCircular(0.36, 0.36, rmDegreesToRadians(5.0));
   else
      rmPlacePlayersCircular(0.37, 0.37, rmDegreesToRadians(5.0));


   float playerFraction=rmAreaTilesToFraction(1700);
   float apx=0.0;
   float apz=0.0;



   for(i=1; <cNumberPlayers)
   {

      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, 0.8*playerFraction, 0.9*playerFraction);
      rmSetAreaMinBlobs(id, 30);
      rmSetAreaMaxBlobs(id, 40);
      rmSetAreaWarnFailure(id, false);
      rmSetAreaSmoothDistance(id, 8);
      rmSetAreaCoherence(id, 0.20);
      rmSetAreaBaseHeight(id, 4.0);
      rmSetAreaHeightBlend(id, 10);
      rmAddAreaConstraint(id, playerConstraint);
      if(cNumberNonGaiaPlayers < 4)
         rmAddAreaConstraint(id, smallMapPlayerConstraint);
      rmSetAreaLocPlayer(id, i);
      rmSetAreaTerrainType(id, "DirtA");
      rmAddAreaToClass(id, classPlayer);
      rmBuildArea(id);

      int id2=rmCreateArea("Player inner"+i);
      rmSetAreaSize(id2, 0.003, 0.003);
      float px=rmPlayerLocXFraction(i);
      float pz=rmPlayerLocZFraction(i);

      float divx=(px-0.5)/5;
      float divz=(pz-0.5)/5;
      float npx=px-divx;
      float npz=pz-divz;
      rmSetAreaLocation(id2, npx, npz);
      rmSetAreaBaseHeight(id2, 3.0);
      rmSetAreaHeightBlend(id2, 5);
      rmSetAreaTerrainType(id2, "CityTileA");
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaCoherence(id2, 0.5);
      rmBuildArea(id2);

      int id3=rmCreateArea("Player outer"+i);
      rmSetAreaSize(id3, 0.0016, 0.0016);


      divx=(px-0.5)/4.5;
      divz=(pz-0.5)/4.5;
      npx=0.5+divx;
      npz=0.5+divz;
      rmSetAreaLocation(id3, npx, npz);

      rmSetAreaTerrainType(id3, "CityTileA");
      rmSetAreaWarnFailure(id3, false);
      rmSetAreaCoherence(id3, 0.8);
      rmBuildArea(id3);

      divx=(px-0.5);
      divz=(pz-0.5);

      float hyp2=divx*divx+divz*divz;
      hyp2=sqrt(hyp2);

      float q = _atan2(divz,divx);
      float w1=rmDegreesToRadians(180.0 / cNumberPlayers);
      float q1=q+w1;
//      if (q1>PI)q1=q1-PI;

      float c = _cos(q1);
      float s = _sin(q1);

      int id4=rmCreateArea("Player left"+i);
      rmSetAreaSize(id4, 0.013, 0.014);

	  apx = c*hyp2*1.043 + 0.5;
	  apz = s*hyp2*1.043 + 0.5;

      rmSetAreaLocation(id4, apx, apz);
      rmSetAreaBaseHeight(id4, 0.0);
      rmSetAreaHeightBlend(id4, 2);
      rmSetAreaWaterType(id4, "Greek River");

      rmSetAreaCoherence(id4, 0.3);
      rmSetAreaMinBlobs(id4, 10);
      rmSetAreaMaxBlobs(id4, 15);
      rmSetAreaMinBlobDistance(id4, 5);
      rmSetAreaMaxBlobDistance(id4, 12);

      npx = c*hyp2/1.65 + 0.5;
	  npz = s*hyp2/1.65 + 0.5;

      rmAddAreaInfluenceSegment(id4, apx, apz, npx, npz);
      rmAddAreaToClass(id4, classbetw);

      rmBuildArea(id4);

      int id5=rmCreateArea("Player lefto"+i);
      rmSetAreaSize(id5, 0.006, 0.006);

	  rmSetAreaLocation(id5, apx, apz);
      rmSetAreaBaseHeight(id5, 0.0);
      rmSetAreaHeightBlend(id5, 3);
      rmSetAreaWaterType(id5, "Greek River");

      rmSetAreaCoherence(id5, 0.5);
      rmAddAreaToClass(id5, classbetw);

      rmBuildArea(id5);



   }

   int centerID=rmCreateArea("center0");
   rmSetAreaSize(centerID, 0.15, 0.15);
   rmSetAreaLocation(centerID, 0.5, 0.5);
   rmSetAreaWaterType(centerID, "Greek River");

   rmSetAreaHeightBlend(centerID, 4);
   rmSetAreaBaseHeight(centerID, 1.0);
   rmSetAreaMinBlobs(centerID, 8);
   rmSetAreaMaxBlobs(centerID, 10);
   rmSetAreaMinBlobDistance(centerID, 10);
   rmSetAreaMaxBlobDistance(centerID, 12);
   rmSetAreaSmoothDistance(centerID, 1);
   rmSetAreaCoherence(centerID, 0.3);
   rmAddAreaConstraint(centerID, smallMapPlayerConstraint);
   rmAddAreaToClass(centerID, classCenter);
   rmBuildArea(centerID);



   int centerID01=rmCreateArea("center01");
   rmSetAreaSize(centerID01, 0.07, 0.07);
   rmSetAreaLocation(centerID01, 0.5, 0.5);

   rmSetAreaCliffType(centerID01, "Greek Rock");
   rmSetAreaCliffEdge(centerID01, 1, 0.98, 1, 0.2, 0);
   rmSetAreaHeightBlend(centerID01, 6);
   rmSetAreaBaseHeight(centerID01, 8.0);
   rmSetAreaMinBlobs(centerID01, 5);
   rmSetAreaMaxBlobs(centerID01, 8);
   rmSetAreaMinBlobDistance(centerID01, 3);
   rmSetAreaMaxBlobDistance(centerID01, 5);
   rmSetAreaSmoothDistance(centerID01, 0.3);
   rmSetAreaCoherence(centerID01, 0.3);
   rmAddAreaConstraint(centerID01, smallMapPlayerConstraint);
   rmBuildArea(centerID01);


   int startingSettlementID=rmCreateObjectDef("starting settlement");
   rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
   rmSetObjectDefMinDistance(startingSettlementID, 0.0);
   rmSetObjectDefMaxDistance(startingSettlementID, 0.0);
   rmPlaceObjectDefPerPlayer(startingSettlementID, true, 1);

   int startingTowerID=rmCreateObjectDef("Starting tower");
   rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
   rmSetObjectDefMinDistance(startingTowerID, 29.0);
   rmSetObjectDefMaxDistance(startingTowerID, 32.0);
   rmAddObjectDefConstraint(startingTowerID, avoidTower);
   rmAddObjectDefConstraint(startingTowerID, avoidImpassableLand);
   rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);




   id=rmAddFairLoc("Settlement", false, true,  35, 37, 25, 25);
   id=rmAddFairLoc("Settlement", true, false, 50, 55, 25, 25);


   if(rmPlaceFairLocs())
   {
      id=rmCreateObjectDef("far settlement2");
      rmAddObjectDefItem(id, "Settlement", 1, 0.0);
      rmAddObjectDefConstraint(id, avoidImpassableLand);
      rmAddObjectDefConstraint(id, smallCenterConstraint);
      for(i=1; <cNumberPlayers)
      {
         for(j=0; <rmGetNumberFairLocs(i))
            rmPlaceObjectDefAtLoc(id, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
      }
   }

   rmBuildAllAreas();


   rmSetStatusText("",0.1);
   int x=1;
   int y=1;
   float xf=0.012;
   float yf=0.012;
   while(y<3){
     while(x<3){
      int outcenterID1=rmCreateArea("outcenter"+y+x);
      rmSetAreaSize(outcenterID1, 0.031, 0.031);
      rmSetAreaLocation(outcenterID1, xf, yf);
      x=x+1;
      xf=0.988;
      rmSetAreaWaterType(outcenterID1, "Greek River");
      rmSetAreaBaseHeight(outcenterID1, 0.0);
      rmSetAreaMinBlobs(outcenterID1, 20);
      rmSetAreaMaxBlobs(outcenterID1, 25);
      rmSetAreaMinBlobDistance(outcenterID1, 5);
      rmSetAreaMaxBlobDistance(outcenterID1, 25);
  //    rmSetAreaSmoothDistance(outcenterID1, 12);
      rmSetAreaCoherence(outcenterID1, 0.2);
      rmAddAreaConstraint(outcenterID1, shortAvoidSettlement);
      rmBuildArea(outcenterID1);
     }
     xf=0.012;
     x=1;
     y=y+1;
     yf=0.988;
   }

   rmBuildAllAreas();


   int center2ID=rmCreateArea("center2", centerID01);
   rmSetAreaSize(center2ID, 0.04, 0.04);
   rmSetAreaLocation(center2ID, 0.5, 0.5);
   rmSetAreaTerrainType(center2ID, "SavannahB");
   rmSetAreaHeightBlend(center2ID, 5);
   rmSetAreaBaseHeight(center2ID, 1.5);
   rmSetAreaMinBlobs(center2ID, 20);
   rmSetAreaMaxBlobs(center2ID, 30);
   rmSetAreaMinBlobDistance(center2ID, 10);
   rmSetAreaMaxBlobDistance(center2ID, 15);
   rmSetAreaSmoothDistance(center2ID, 2);
   rmSetAreaCoherence(center2ID, 0.2);
   rmAddAreaConstraint(center2ID, shortAvoidSettlement);
   rmAddAreaToClass(center2ID, classCenter);
   rmAddAreaToClass(center2ID, classinnerCenter);
   rmBuildArea(center2ID);


   int loops=15;
   for(i=0;<loops){
     int isid=rmCreateObjectDef("far settlement3");
     rmAddObjectDefItem(isid, "Settlement", 2, 35.0);
     rmAddObjectDefConstraint(isid, avoidImpassableLand);
     rmPlaceObjectDefAtAreaLoc(isid, 0, center2ID, 1);
     if(rmGetNumberUnitsPlaced(isid) > 0)
        break;
   }


   int innerSeaID=rmCreateArea("innerSea", center2ID);
   rmSetAreaSize(innerSeaID, 0.011, 0.013);
   rmSetAreaWaterType(innerSeaID, "Greek River");
   rmSetAreaBaseHeight(innerSeaID, 1.0);
   rmSetAreaMinBlobs(innerSeaID, 12);
   rmSetAreaMaxBlobs(innerSeaID, 15);
   rmSetAreaMinBlobDistance(innerSeaID, 8);
   rmSetAreaMaxBlobDistance(innerSeaID, 10);
   rmSetAreaSmoothDistance(innerSeaID, 2);
   rmSetAreaCoherence(innerSeaID, 0.3);
   rmAddAreaConstraint(innerSeaID, shortAvoidSettlement);
   rmBuildArea(innerSeaID);




   int innerGoldID=rmCreateObjectDef("innergold");
   rmAddObjectDefItem(innerGoldID, "Gold mine", 2, 30.0);
   rmAddObjectDefConstraint(innerGoldID, avoidGold);
   rmAddObjectDefConstraint(innerGoldID, shortAvoidSettlement);
   rmAddObjectDefConstraint(innerGoldID, avoidImpassableLand);
   rmPlaceObjectDefInArea(innerGoldID, 0, center2ID, 3);
   int innerGoldUID1 = rmGetUnitPlaced(innerGoldID, 0);
   int innerGoldUID2 = rmGetUnitPlaced(innerGoldID, 1);
   rmEchoInfo("innergold"+innerGoldUID1);
   rmEchoInfo("innergold"+innerGoldUID2);


   int mNorseID=rmCreateObjectDef("Rave1");
   rmAddObjectDefItem(mNorseID, "Raven", 1, 10.0);
   rmAddObjectDefConstraint(mNorseID, avoidImpassableLand);
   rmAddObjectDefConstraint(mNorseID, shortAvoidSettlement);
   int mGreekID=rmCreateObjectDef("Rave2");
   rmAddObjectDefItem(mGreekID, "Raven", 1, 10.0);
   rmAddObjectDefConstraint(mGreekID, avoidImpassableLand);
   rmAddObjectDefConstraint(mGreekID, shortAvoidSettlement);
   int mEgyptianID=rmCreateObjectDef("Rave3");
   rmAddObjectDefItem(mEgyptianID, "Raven", 1, 10.0);
   rmAddObjectDefConstraint(mEgyptianID, avoidImpassableLand);
   rmAddObjectDefConstraint(mEgyptianID, shortAvoidSettlement);

   for(i=1; <cNumberPlayers)
   {
      int tocenterID=rmCreateConnection("tocenter"+i);
      rmSetConnectionType(tocenterID, cConnectAreas, false, 1.0);
      rmSetConnectionPositionVariance(tocenterID, 25);
      rmAddConnectionArea(tocenterID, rmAreaID("Player inner"+i));
      rmAddConnectionArea(tocenterID, rmAreaID("Player outer"+i));
 //     rmAddConnectionArea(tocenterID, centerID01);

      rmSetConnectionBaseHeight(tocenterID, 3.0);
      rmSetConnectionHeightBlend(tocenterID, 0.5);
      rmSetConnectionWidth(tocenterID, 10.0, 0.2);
      rmSetConnectionBaseTerrainCost(tocenterID, 10.0);
      rmAddConnectionTerrainReplacement(tocenterID, "DirtA", "CityTileA");
      rmAddConnectionTerrainReplacement(tocenterID, "GrassDirt25", "CityTileA");
      rmAddConnectionTerrainReplacement(tocenterID, "GrassDirt50", "CityTileA");
      rmAddConnectionTerrainReplacement(tocenterID, "GrassDirt75", "CityTileA");
      rmAddConnectionTerrainReplacement(tocenterID, "SavannahB", "CityTileA");
      rmAddConnectionTerrainReplacement(tocenterID, "SavannahD", "CityTileA");
      rmAddConnectionTerrainReplacement(tocenterID, "CliffGreekA", "CityTileA");
      rmAddConnectionToClass(tocenterID, classConnect);
      rmBuildConnection(tocenterID);


      id2=rmAreaID("Player inner"+i);
	 if(rmGetPlayerCulture(i) == cCultureGreek)
	   rmPlaceObjectDefInArea(mGreekID, i,id2 ,1);
	 else if(rmGetPlayerCulture(i) == cCultureNorse)
	   rmPlaceObjectDefInArea(mNorseID, i,id2 ,1);
	 else if(rmGetPlayerCulture(i) == cCultureEgyptian)
	   rmPlaceObjectDefInArea(mEgyptianID, i,id2 ,1);


   }


   rmSetStatusText("",0.3);

   int numTries=3*cNumberNonGaiaPlayers;
   int failCount=0;
   int addonID=0;
   for(i=0; <numTries)
   {
      int elevID=rmCreateArea("elev"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(130), rmAreaTilesToFraction(140));
      rmSetAreaWarnFailure(elevID, false);
      rmAddAreaToClass(elevID, rmClassID("classHill"));
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmAddAreaConstraint(elevID, smallCenterConstraint);
      rmAddAreaConstraint(elevID, connectConstrain);
      rmAddAreaConstraint(elevID, shortAvoidSettlement);
      rmAddAreaConstraint(elevID, betwConstraint);
      if(rmRandFloat(0.0, 1.0)<0.5)
         rmSetAreaTerrainType(elevID, "MiningGround");
      else
         rmSetAreaTerrainType(elevID, "ForestfloorPine");
      rmSetAreaBaseHeight(elevID, rmRandFloat(2.0, 5.0));
      rmSetAreaHeightBlend(elevID, 3);
      rmSetAreaMinBlobs(elevID, 20);
      rmSetAreaMaxBlobs(elevID, 30);
      rmSetAreaMinBlobDistance(elevID, 8.0);
      rmSetAreaMaxBlobDistance(elevID, 10.0);
      rmSetAreaCoherence(elevID, 0.3);

      if(rmBuildArea(elevID)==false)

      {
         // Stop trying once we fail 20 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         addonID=rmCreateObjectDef("monsterA"+i);
         rmAddObjectDefItem(addonID, "Tamarisk Tree", 1, 0.0);
         rmPlaceObjectDefInArea(addonID, 0, elevID, 1);

         addonID=rmCreateObjectDef("monsterB"+i);
         rmAddObjectDefItem(addonID, "Skeleton Giant", 1, 0.0);
         rmPlaceObjectDefInArea(addonID, 0, elevID, 1);
         failCount=0;
   }





   float pigNumber=rmRandFloat(2, 3);
   int startingPigsID=rmCreateObjectDef("start pigs");
   rmAddObjectDefItem(startingPigsID, "pig", pigNumber, 2.0);
   rmSetObjectDefMinDistance(startingPigsID, 31.0);
   rmSetObjectDefMaxDistance(startingPigsID, 34.0);
   rmAddObjectDefConstraint(startingPigsID, avoidImpassableLand);
   rmAddObjectDefConstraint(startingPigsID, avoidFood);
   rmPlaceObjectDefPerPlayer(startingPigsID, true, 2);

   int startingGoldID=rmCreateObjectDef("Starting gold");
   rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
   rmSetObjectDefMinDistance(startingGoldID, 20.0);
   rmSetObjectDefMaxDistance(startingGoldID, 25.0);
   rmAddObjectDefConstraint(startingGoldID, avoidGold);
   rmAddObjectDefConstraint(startingGoldID, avoidImpassableLand);

   rmPlaceObjectDefPerPlayer(startingGoldID, false);



   int relicID=rmCreateObjectDef("relic");
   rmAddObjectDefItem(relicID, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(relicID, 60.0);
   rmSetObjectDefMaxDistance(relicID, 150.0);
   rmAddObjectDefConstraint(relicID, edgeConstraint);
   rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 70.0));
   rmAddObjectDefConstraint(relicID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(relicID, avoidImpassableLand);

   int randomTreeID=rmCreateObjectDef("random tree");
   rmAddObjectDefItem(randomTreeID, "oak tree", 1, 0.0);
   rmSetObjectDefMinDistance(randomTreeID, 0.0);
   rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 10.0));
   rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
   rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
   rmAddObjectDefConstraint(randomTreeID, betwConstraint);

   int farGoldID=rmCreateObjectDef("far gold");
   rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(farGoldID, 70.0);
   rmSetObjectDefMaxDistance(farGoldID, 160.0);
   rmAddObjectDefConstraint(farGoldID, avoidGold);
   rmAddObjectDefConstraint(farGoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(farGoldID, shortAvoidSettlement);
   rmAddObjectDefConstraint(farGoldID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(farGoldID, connectConstrain);

   int mediumGoldID=rmCreateObjectDef("medium gold");
   rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(mediumGoldID, 40.0);
   rmSetObjectDefMaxDistance(mediumGoldID, 60.0);
   rmAddObjectDefConstraint(mediumGoldID, avoidGold);
   rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
   rmAddObjectDefConstraint(mediumGoldID, shortAvoidSettlement);
   rmAddObjectDefConstraint(mediumGoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(mediumGoldID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(mediumGoldID, connectConstrain);


   rmPlaceObjectDefPerPlayer(mediumGoldID, false, 2);
   rmPlaceObjectDefPerPlayer(farGoldID, false, 2);
   rmPlaceObjectDefPerPlayer(relicID, false, 1);
   rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);







   int playerFishID=rmCreateObjectDef("owned fish");
   rmAddObjectDefItem(playerFishID, "fish - mahi", 3, 10.0);
   rmSetObjectDefMinDistance(playerFishID, 0.0);
   rmSetObjectDefMaxDistance(playerFishID, 100.0);
   rmAddObjectDefConstraint(playerFishID, fishVsFishID);
   rmAddObjectDefConstraint(playerFishID, fishLand);

   rmPlaceObjectDefPerPlayer(playerFishID, false);


   int hfishID=rmCreateObjectDef("hippocampus");
   rmAddObjectDefItem(hfishID, "hippocampus", 2, 15.0);
   rmSetObjectDefMinDistance(hfishID, 0.0);
   rmSetObjectDefMaxDistance(hfishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(hfishID, fishVsFishID);
   rmAddObjectDefConstraint(hfishID, fishLand);
   rmPlaceObjectDefAtLoc(hfishID, 0, 0.5, 0.5, 2);


   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "fish - mahi", 3, 9.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

   fishID=rmCreateObjectDef("fish2");
   rmAddObjectDefItem(fishID, "fish - perch", 2, 6.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);

   int msCid=rmCreateObjectDef("monsterA");
   rmAddObjectDefItem(msCid, "Tamarisk Tree", 2, 50.0);
   rmPlaceObjectDefInArea(msCid, 0, center2ID, 1);

   int ssCid=rmCreateObjectDef("monsterB");
   rmAddObjectDefItem(ssCid, "Troll", 6, 25.0);

   rmPlaceObjectDefInArea(ssCid, 0, center2ID, 1);
   int trollUID1 = rmGetUnitPlaced(ssCid, 0);
   int trollUID2 = rmGetUnitPlaced(ssCid, 1);
   int trollUID3 = rmGetUnitPlaced(ssCid, 2);
   int trollUID4 = rmGetUnitPlaced(ssCid, 3);
   int trollUID5 = rmGetUnitPlaced(ssCid, 4);
   int trollUID6 = rmGetUnitPlaced(ssCid, 5);

   int ssCid1=rmCreateObjectDef("monsterC");
   rmAddObjectDefItem(ssCid1, "Nidhogg", 1, 0.0);
   rmPlaceObjectDefInArea(ssCid1, 0, center2ID, 1);

   for(i=1; <20){
    int centerdID=rmCreateArea("centerd"+i);
    rmSetAreaSize(centerdID, 0.001, 0.004);
    rmSetAreaCliffType(centerdID, "Greek Rock");
    rmSetAreaBaseHeight(centerdID, 6.0);
    rmSetAreaSmoothDistance(centerdID, 6);
    rmSetAreaHeightBlend(centerdID, 2);
    rmSetAreaCoherence(centerdID, 0.5);
    rmSetAreaMinBlobDistance(centerdID, 8);
    rmSetAreaMaxBlobDistance(centerdID, 10);
    rmSetAreaMinBlobs(centerdID, 8);
    rmSetAreaMaxBlobs(centerdID, 10);
    rmSetAreaCliffEdge(centerdID, 3, 1, 0.3, 0.3, 0);
    rmAddAreaConstraint(centerdID, placeConstraint);
    rmAddAreaConstraint(centerdID, smallCenterConstraint);
    rmAddAreaConstraint(centerdID, shortAvoidSettlement);
    rmAddAreaConstraint(centerdID, avoidBuildings);
    rmAddAreaConstraint(centerdID, betwConstraint);

    rmSetAreaWarnFailure(centerdID, false);
    rmBuildArea(centerdID);
   }



   failCount=0;
   for(i=0; <25)
   {
      int forestID=rmCreateArea("forest"+i);
      rmSetAreaSize(forestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(600));
      rmSetAreaWarnFailure(forestID, false);
      if(rmRandFloat(0.0, 1.0)<0.5)
         rmSetAreaForestType(forestID, "oak forest");
      else
         rmSetAreaForestType(forestID, "pine forest");
      rmAddAreaConstraint(forestID, forestSettleConstraint);
      rmAddAreaConstraint(forestID, forestObjConstraint);
      rmAddAreaConstraint(forestID, forestConstraint);
      rmAddAreaConstraint(forestID, avoidImpassableLand);
      rmAddAreaConstraint(forestID, connectConstrain);
      rmAddAreaConstraint(forestID, betwConstraint);
  //    rmAddAreaConstraint(forestID, shortAvoidSettlement);
      rmAddAreaToClass(forestID, classForest);

      rmSetAreaMinBlobs(forestID, 8);
      rmSetAreaMaxBlobs(forestID, 20);
      rmSetAreaMinBlobDistance(forestID, 10.0);
      rmSetAreaMaxBlobDistance(forestID, 15.0);
      rmSetAreaCoherence(forestID, 0.0);

      if(rmBuildArea(forestID)==false)
      {
         failCount++;
         if(failCount==6)
            break;
      }
      else
         failCount=0;
   }

   rmSetStatusText("",0.5);



   int ulfID=rmCreateObjectDef("ulfA");
   rmAddObjectDefItem(ulfID, "Skraeling", 3, 5.0);
   rmAddObjectDefConstraint(ulfID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(ulfID, smallCenterConstraint);
   rmAddObjectDefConstraint(ulfID, avoidImpassableLand);
   rmPlaceObjectDefAtLoc(ulfID, 0, 0.5, 0.5, 1*cNumberNonGaiaPlayers);






   int farPredatorID=rmCreateObjectDef("far predator");
   float predatorSpecies=rmRandFloat(0, 1);
   if(predatorSpecies<0.5)
      rmAddObjectDefItem(farPredatorID, "lion", 2, 4.0);
   else
      rmAddObjectDefItem(farPredatorID, "bear", 1, 4.0);
   rmSetObjectDefMinDistance(farPredatorID, 50.0);
   rmSetObjectDefMaxDistance(farPredatorID, 100.0);
   rmAddObjectDefConstraint(farPredatorID, avoidPredator);
   rmAddObjectDefConstraint(farPredatorID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(farPredatorID, avoidImpassableLand);
   rmPlaceObjectDefAtLoc(farPredatorID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);


      // hunted avoids hunted and TCs
   int bonusHuntableID=rmCreateObjectDef("bonus huntable");
   float bonusChance=rmRandFloat(0, 1);
   if(bonusChance<0.5)
      rmAddObjectDefItem(bonusHuntableID, "boar", rmRandInt(2,3), 4.0);
   else if(bonusChance<0.8)
      rmAddObjectDefItem(bonusHuntableID, "deer", rmRandInt(6,8), 8.0);
   else
      rmAddObjectDefItem(bonusHuntableID, "aurochs", rmRandInt(1,3), 4.0);
   rmSetObjectDefMinDistance(bonusHuntableID, 0.0);
   rmSetObjectDefMaxDistance(bonusHuntableID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(bonusHuntableID, avoidBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, avoidHuntable);
   rmAddObjectDefToClass(bonusHuntableID, classBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(bonusHuntableID, avoidImpassableLand);
   rmPlaceObjectDefAtLoc(bonusHuntableID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);




   for (i=0;<5){
     int desAID=rmCreateObjectDef("Div"+i);
     if(rmRandFloat(0.0, 1.0)<0.8)
       rmAddObjectDefItem(desAID, "Ruins", 1, 0.0);
     else
       rmAddObjectDefItem(desAID, "Savannah Tree Burning", 1, 0.0);
     rmSetObjectDefMinDistance(desAID, 0.0);
     rmSetObjectDefMaxDistance(desAID, rmXFractionToMeters(0.5));
     rmAddObjectDefConstraint(desAID, avoidAll);
     rmAddObjectDefConstraint(desAID, avoidBuildings);
     rmAddObjectDefConstraint(desAID, avoidImpassableLand);
     rmPlaceObjectDefAtLoc(desAID, 0, 0.5, 0.5, 2);
   }

   int deerID=rmCreateObjectDef("lonely deer");
   if(rmRandFloat(0,1)<0.5)
      rmAddObjectDefItem(deerID, "deer", rmRandInt(1,2), 1.0);
   else
      rmAddObjectDefItem(deerID, "aurochs", 1, 0.0);
   rmSetObjectDefMinDistance(deerID, 0.0);
   rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(deerID, avoidAll);
   rmAddObjectDefConstraint(deerID, avoidBuildings);
   rmAddObjectDefConstraint(deerID, avoidImpassableLand);
   rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

   int avoidGrass=rmCreateTypeDistanceConstraint("avoid grass", "grass", 12.0);
   int grassID=rmCreateObjectDef("grass");
   rmAddObjectDefItem(grassID, "grass", 3, 4.0);
   rmSetObjectDefMinDistance(grassID, 0.0);
   rmSetObjectDefMaxDistance(grassID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(grassID, avoidGrass);
   rmAddObjectDefConstraint(grassID, avoidAll);
   rmAddObjectDefConstraint(grassID, avoidImpassableLand);
   rmAddObjectDefConstraint(grassID, betwConstraint);
   rmPlaceObjectDefAtLoc(grassID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);

   int rockID=rmCreateObjectDef("rock and grass");
   int avoidRock=rmCreateTypeDistanceConstraint("avoid rock", "rock limestone sprite", 8.0);
   rmAddObjectDefItem(rockID, "rock limestone sprite", 1, 1.0);
   rmAddObjectDefItem(rockID, "grass", 2, 1.0);
   rmSetObjectDefMinDistance(rockID, 0.0);
   rmSetObjectDefMaxDistance(rockID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(rockID, avoidAll);
   rmAddObjectDefConstraint(rockID, avoidImpassableLand);
   rmAddObjectDefConstraint(rockID, avoidRock);
   rmAddObjectDefConstraint(rockID, betwConstraint);
   rmPlaceObjectDefAtLoc(rockID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);

   int rockID2=rmCreateObjectDef("rock group");
   rmAddObjectDefItem(rockID2, "rock limestone sprite", 3, 2.0);
   rmSetObjectDefMinDistance(rockID2, 0.0);
   rmSetObjectDefMaxDistance(rockID2, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(rockID2, avoidAll);
   rmAddObjectDefConstraint(rockID2, avoidImpassableLand);
   rmAddObjectDefConstraint(rockID2, avoidRock);
   rmAddObjectDefConstraint(rockID2, shortAvoidSettlement);
   rmAddObjectDefConstraint(rockID2, betwConstraint);

   rmPlaceObjectDefAtLoc(rockID2, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

   int nearshore=rmCreateTerrainMaxDistanceConstraint("seaweed near shore", "land", true, 14.0);
   int farshore = rmCreateTerrainDistanceConstraint("seaweed far from shore", "land", true, 10.0);
   int kelpID=rmCreateObjectDef("seaweed");
   rmAddObjectDefItem(kelpID, "seaweed", 12, 6.0);
   rmSetObjectDefMinDistance(kelpID, 0.0);
   rmSetObjectDefMaxDistance(kelpID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(kelpID, avoidAll);
   rmAddObjectDefConstraint(kelpID, nearshore);
   rmAddObjectDefConstraint(kelpID, farshore);
   rmPlaceObjectDefAtLoc(kelpID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);

   int kelp2ID=rmCreateObjectDef("seaweed 2");
   rmAddObjectDefItem(kelp2ID, "seaweed", 5, 3.0);
   rmSetObjectDefMinDistance(kelp2ID, 0.0);
   rmSetObjectDefMaxDistance(kelp2ID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(kelp2ID, avoidAll);
   rmAddObjectDefConstraint(kelp2ID, nearshore);
   rmAddObjectDefConstraint(kelp2ID, farshore);
   rmPlaceObjectDefAtLoc(kelp2ID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);


   rmSetStatusText("",0.8);


   rmCreateTrigger("tr_innerarea1");
   rmCreateTrigger("tr_innerarea2");
   rmCreateTrigger("tr_snowtimer1");
   rmCreateTrigger("tr_snowtimer2");
  
   
   rmSwitchToTrigger(rmTriggerID("tr_snowtimer1"));
   rmSetTriggerPriority(2);
   rmSetTriggerActive(true);
   rmSetTriggerLoop(false);
   rmSetTriggerRunImmediately(false);

   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerEffect("Render Snow");
   rmSetTriggerEffectParamFloat("Percent", 0.0, false);

   rmSwitchToTrigger(rmTriggerID("tr_snowtimer2"));
   rmSetTriggerPriority(2);
   rmSetTriggerActive(true);
   rmSetTriggerLoop(false);
   rmSetTriggerRunImmediately(false);

   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 20);
   rmAddTriggerEffect("Render Snow");
   rmSetTriggerEffectParamFloat("Percent", 0.0, false);


   rmSwitchToTrigger(rmTriggerID("tr_innerarea1"));
   rmSetTriggerPriority(2);
   rmSetTriggerActive(true);
   rmSetTriggerLoop(false);
   rmSetTriggerRunImmediately(false);

   rmAddTriggerCondition("Visible To Player");
   rmSetTriggerConditionParamInt("SrcObject", innerGoldUID1, false);

   rmAddTriggerEffect("Render Snow");
   rmSetTriggerEffectParamFloat("Percent", 30.0, false);

   rmAddTriggerEffect("Music Filename");
   rmSetTriggerEffectParam("Music", "\music\fight\the fire brigade.mp3", false);
   rmSetTriggerEffectParamFloat("Duration", 4.0, false);

   rmAddTriggerEffect("Move To Unit");
   rmSetTriggerEffectParamInt("SrcObject", trollUID1, false);
   rmSetTriggerEffectParamInt("DstObject", innerGoldUID1, false);
   rmSetTriggerEffectParamInt("EventID", -1, false);
   rmSetTriggerEffectParamInt("AttackMove", true, false);

   rmAddTriggerEffect("Move To Unit");
   rmSetTriggerEffectParamInt("SrcObject", trollUID2, false);
   rmSetTriggerEffectParamInt("DstObject", innerGoldUID1, false);
   rmSetTriggerEffectParamInt("EventID", -1, false);
   rmSetTriggerEffectParamInt("AttackMove", true, false);

   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID", rmTriggerID("tr_snowtimer1"));



   rmSwitchToTrigger(rmTriggerID("tr_innerarea2"));
   rmSetTriggerPriority(2);
   rmSetTriggerActive(true);
   rmSetTriggerLoop(false);
   rmSetTriggerRunImmediately(false);

   rmAddTriggerCondition("Visible To Player");
   rmSetTriggerConditionParamInt("SrcObject", innerGoldUID2, false);


   rmAddTriggerEffect("Render Snow");
   rmSetTriggerEffectParamFloat("Percent", 30.0, false);

   rmAddTriggerEffect("Music Filename");
   rmSetTriggerEffectParam("Music", "\music\fight\the fire brigade.mp3", false);
   rmSetTriggerEffectParamFloat("Duration", 4.0, false);

   rmAddTriggerEffect("Move To Unit");
   rmSetTriggerEffectParamInt("SrcObject", trollUID3, false);
   rmSetTriggerEffectParamInt("DstObject", innerGoldUID2, false);
   rmSetTriggerEffectParamInt("EventID", -1, false);
   rmSetTriggerEffectParamInt("AttackMove", true, false);

   rmAddTriggerEffect("Move To Unit");
   rmSetTriggerEffectParamInt("SrcObject", trollUID4, false);
   rmSetTriggerEffectParamInt("DstObject", innerGoldUID2, false);
   rmSetTriggerEffectParamInt("EventID", -1, false);
   rmSetTriggerEffectParamInt("AttackMove", true, false);

   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID", rmTriggerID("tr_snowtimer2"));






   rmSetStatusText("",1.0);

}